import java.io.*;

public class FQone2Fasta {
	
	private static String caller= "compSubtr.bioinformaticsTools.FQone2Fasta ";

	public static void main(String args[]) throws FileNotFoundException {

		String inputFile=  args[0]; //FQ1
		String outputFile= args[1]; //FA
		
		long start = System.currentTimeMillis();
		
		int seqCounter = 0;



		try{
			BufferedWriter out = new BufferedWriter(new FileWriter(outputFile));
			FileReader fr1=new FileReader(inputFile);
			BufferedReader br=new BufferedReader(fr1);
			String strLine;
		
			while ((strLine = br.readLine()) != null)   {
				seqCounter++;
				String[] column= strLine.split("\t");
				out.write(">" + column[0] + "\n" + 
						        column[1] + "\n" );
			}
			long elapsedTimeMillis = System.currentTimeMillis()-start;
			 float elapsedTimeSec = elapsedTimeMillis/1000F;
			System.out.println(seqCounter+" reads in this dataset." + "  Amount of time: "+elapsedTimeSec);
			
			
			fr1.close();
			out.flush();
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
	public static String getCaller() {
		return caller;
	}
}
