/*
	Author: Chandra Sekhar Pedamallu
	Description: This program meant to parser blastoutput in XML format

	Input:<XML output> <output in Hit Table> 
	
	Updates:
	none
	
*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include<stdio.h>
#include<fstream>
#include<iostream>
#include<vector>
#include<time.h>

using namespace std;
const int no_put=10;
char* trim(char *str){
	 char* cp;
	while(*str && strchr(" \n\r\t", *str)!=NULL)
		str++;
	cp=str+strlen(str)-1;
	while(cp>str && strchr(" \n\r\t", *cp)!=NULL)
		*cp-- = '\0';
	return str;
}

string getsvalue(string line){
	char *str;
	str=new char[line.size()+1];
	strcpy(str, line.c_str());
	char *strtemp = trim(str);
	string ind;	
	if(strlen(strtemp)>0){
		char *p;
		int count=0;
		p=strtok(str, "<");
		while(p!=NULL){
			if(count==0){ind=p;}
			p=strtok(NULL,"<");
			count++;
		}
	}	
	return ind;
}

int main(int argc, char* argv[]){
	time_t start, end;
	time(&start); // Start time
	//printf("%s\n", "Start");
if(argc < 2){
	cout<<"please check your Arguments"<<endl;
	cout<<"./blastxml <XML formatoutput> <outputfile in Hittable>"<<endl;
	exit(0);	
}
	cout<<"Output file : "<<argv[2]<<endl;
	ofstream outfile(argv[2]);
        
// Blast XML file 

	ifstream fin(argv[1]);
	vector<string> chr;
	vector<int> chrstart;
	vector<string> read;
	string line;
	int no_line=0;
	string Query="", Query_len="";
	vector<string> Hit_num;vector<string> Hit_id;vector<string> Hit_def;
	vector<string> Hit_acc;vector<string> Hit_len;vector<string> Bit_sc;
	vector<string> Eval; vector<string> Hsp_hit_fr;
	vector<string> Hsp_hit_to; vector<string> Hsp_ident; vector<string> Hsp_align_len;
	vector<double> iden; vector<double> qcover; vector<string> Hsp_q_fr; vector<string> Hsp_q_to; 
	vector<string> Hsp_qseq;
	vector<string> q_start;
	vector<string> q_end;
	if(fin.is_open()){
		int frec = 0;
		int Hspident=0;
		int Hspalign=0;
		int Qleng=0;
		
		while(!fin.eof()){
			getline(fin, line);
			if(line.size()>0){
				char *str;
				str=new char[line.size()+1];
				strcpy(str, line.c_str());
				char *strtemp = trim(str);
				string ind;	
				string sin;
			//	cout<<strtemp<<endl;
				if(strlen(strtemp)>0){
					char *p;
					int count=0;
					p=strtok(strtemp, ">");
					while(p!=NULL){
						if(count==0){ind=p;}
						else if(count==1){sin=p;}	
						p=strtok(NULL,">");
						count++;
					}
					
				}
			//	cout<<ind<<endl;
				if(ind.compare("<Iteration")==0){
					if(frec>1){
						if(Hit_num.size() > 0){
							for(int i=0; i< Hit_num.size(); i++){
								outfile<<Query<<"\t"<<Query_len<<"\t";
								outfile<<Hit_num.at(i)<<"\t"<<Hit_id.at(i)<<"\t";
								outfile<<Hit_def.at(i)<<"\t"<<Hit_acc.at(i)<<"\t";
								outfile<<Hit_len.at(i)<<"\t"<<Bit_sc.at(i)<<"\t";
								outfile<<Eval.at(i)<<"\t"<<Hsp_hit_fr.at(i)<<"\t";
								outfile<<Hsp_hit_to.at(i)<<"\t"<<Hsp_ident.at(i)<<"\t";
								outfile<<Hsp_align_len.at(i)<<"\t"<<iden.at(i)<<"\t";
								outfile<<qcover.at(i)<<"\t";
								outfile<<Hsp_q_fr.at(i)<<"\t";
								outfile<<Hsp_q_to.at(i)<<"\t"<<Hsp_qseq.at(i)<<endl;
							}
							
						}
					}
					frec++;
					Query=""; Query_len="";Hit_num.clear();Hit_id.clear();Hit_def.clear();
					Hit_acc.clear();Hit_len.clear();Bit_sc.clear();Eval.clear();Hsp_hit_fr.clear();
					Hsp_hit_to.clear();Hsp_ident.clear();Hsp_align_len.clear();iden.clear();
					qcover.clear();Hsp_q_fr.clear();Hsp_q_to.clear();Hsp_qseq.clear();
					q_start.clear();q_end.clear();
				}
				else if(ind.compare("<Iteration_query-def")==0){
					Query=getsvalue(sin);
				}
				else if(ind.compare("<Iteration_query-len")==0){
					Query_len=getsvalue(sin);
				}
				else if(ind.compare("<Hit_num")==0){
					Hit_num.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hit_id")==0){
					Hit_id.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hit_def")==0){
					Hit_def.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hit_accession")==0){
					Hit_acc.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hit_len")==0){
					Hit_len.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_bit-score")==0){
					Bit_sc.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_evalue")==0){
					Eval.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_hit-from")==0){
					Hsp_hit_fr.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_hit-to")==0){
					Hsp_hit_to.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_identity")==0){
					Hsp_ident.push_back(getsvalue(sin));
					string sst12=getsvalue(sin);
					char *str12;
					str12=new char[sst12.size()+1];
					strcpy(str12, sst12.c_str());
					char *strtemp12 = trim(str12);
					Hspident=atoi(strtemp12);
				}
				else if(ind.compare("<Hsp_align-len")==0){
					Hsp_align_len.push_back(getsvalue(sin));
					string sst12=getsvalue(sin);
					char *str12;
					str12=new char[sst12.size()+1];
					strcpy(str12, sst12.c_str());
					char *strtemp12 = trim(str12);
					Hspalign=atoi(strtemp12);
					double identcover = (Hspident+0.0)/(Hspalign);
					iden.push_back(identcover);

					char *str123;
					str123=new char[Query_len.size()+1];
					strcpy(str123, Query_len.c_str());
					char *strtemp123 = trim(str123);

					int Qlength=atoi(str123);
					//double qcover1=(Hspalign+0.0)/(Qlength); //Old query coverage
				
					string qfrom=Hsp_q_fr.at(Hsp_q_fr.size()-1);
					char *str1234;
					str1234=new char[qfrom.size()+1];
					strcpy(str1234, qfrom.c_str());
					char *strtemp1234 = trim(str1234);
					int QFlength=atoi(str1234);

					string qto=Hsp_q_to.at(Hsp_q_to.size()-1);
					char *str12345=new char[qto.size()+1];	
					strcpy(str12345, qto.c_str());
                                        char *strtemp12345 = trim(str12345);
					int QTlength=atoi(str12345);

					double lengthQ=0.0;
					if(QFlength > QTlength){lengthQ=QFlength-QTlength+1;}
					else{lengthQ=QTlength-QFlength+1;}
					double qcover1=(lengthQ+0.0)/(Qlength); //new query coverage
					qcover.push_back(qcover1);
				}
				else if(ind.compare("<Hsp_query-to")==0){
					Hsp_q_to.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_query-from")==0){
					Hsp_q_fr.push_back(getsvalue(sin));
				}
				else if(ind.compare("<Hsp_qseq")==0){
					Hsp_qseq.push_back(getsvalue(sin));
				}



			}
		}
	}
	fin.close();
	
	if(Hit_num.size() > 0){
		for(int i=0; i< Hit_num.size(); i++){
			outfile<<Query<<"\t"<<Query_len<<"\t";
			outfile<<Hit_num.at(i)<<"\t"<<Hit_id.at(i)<<"\t";
			outfile<<Hit_def.at(i)<<"\t"<<Hit_acc.at(i)<<"\t";
			outfile<<Hit_len.at(i)<<"\t"<<Bit_sc.at(i)<<"\t";
			outfile<<Eval.at(i)<<"\t"<<Hsp_hit_fr.at(i)<<"\t";
			outfile<<Hsp_hit_to.at(i)<<"\t"<<Hsp_ident.at(i)<<"\t";
			outfile<<Hsp_align_len.at(i)<<"\t"<<iden.at(i)<<"\t";
			outfile<<qcover.at(i)<<"\t"<<Hsp_q_fr.at(i)<<"\t";
			outfile<<Hsp_q_to.at(i)<<"\t"<<Hsp_qseq.at(i)<<endl;
		}

	}
	outfile.close();

	time(&end);
	double dif=difftime(end, start); // End time
	cout<<"Time"<<dif<<endl;

	return 0;
}

