#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: After Duplicate remover redistribute for Repeat masker
# DFCI @ copyright

import sys
import os
import commands
import random

hadooploc="/usr/local/hadoop-1.0.3"
output=""
stat=""
rinput=""
nclus=20
ccount=0
for arg in sys.argv:
	if ccount==1:
		rinput=arg
	elif ccount==2:
		stat=arg
	elif ccount==3:
		output=arg
	elif ccount==4:
		nclus=int(arg)
	elif ccount==5:
		velinput=arg

	ccount=ccount+1

print rinput
print output

nfolder=rinput

nnFILE=".fq1." + rinput
nnFILE1=rinput + ".fq1"
nFASTA=rinput + ".fasta"

sBRP="totalreads.stat.BPOSTSUB"  # Before postsubstraction
sCON="totalreads.stat.CONTIGS"  # Number of contig

mkdir1="/bin/mkdir /mnt/mfiles/" + nfolder
mkdir=commands.getstatusoutput(mkdir1)
print mkdir

wget1="/usr/bin/s3cmd -f -c /root/.s3cfg ls s3://"
wget1=wget1 + rinput
wget1=wget1 + " | awk '{print \"/usr/bin/s3cmd -f -c /root/.s3cfg get \"$4\" "
wget1=wget1 + "/mnt/mfiles/"
wget1=wget1 + nfolder
wget1=wget1 + "\""
wget1=wget1 + ";}' > /mnt/mfiles/run.cmd"
print wget1
wget=commands.getstatusoutput(wget1)

wget=commands.getstatusoutput("chmod 777 -R /mnt/mfiles/run.cmd")
wget=commands.getstatusoutput("/mnt/mfiles/run.cmd")

print "concat"


# Concat all files downloaded into a temporary file
cat1="/usr/bin/find /mnt/mfiles/" + nfolder
cat1=cat1 + "/ -name \"*.fq1\" -print | xargs cat >> /mnt/mfiles/"
cat1=cat1 + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE
print cat1
wget=commands.getstatusoutput(cat1)
print wget

# Concat all files downloaded into a temporary file
cat1="/usr/cp /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE
cat1=cat1 + " /mnt/mfiles/tmp"
print cat1
wget=commands.getstatusoutput(cat1)
print wget
#find /mnt/mfiles/ami-ami-ccgdlane82-repeato/ -name "*.fq1" | xargs rm

# remove all files except temporary file
cat1="/usr/bin/find /mnt/mfiles/" + nfolder
cat1=cat1 + "/ -name \"*.fq1\" | xargs rm"
print cat1
wget=commands.getstatusoutput(cat1)
print wget

# move temp. file into FQ1
cat1="/bin/mv /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE
cat1=cat1 + " /mnt/mfiles/"
cat1=cat1 + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE1
wget=commands.getstatusoutput(cat1)
print wget

#Total reads before Post subtraction - STATISTICS
print "Statistics before Postsubtraction"
STAT1="/usr/bin/wc -l /mnt/mfiles/" + nfolder
STAT1=STAT1 + "/"
STAT1=STAT1 + nnFILE1
STAT1=STAT1 + " > /mnt/mfiles/reads/"
STAT1=STAT1 + sBRP
STAT=commands.getstatusoutput(STAT1);
print STAT

#Upload the Statistics of reads before Postsub
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sBRP
out1=out1 + " s3://"
out1=out1 + stat
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)
print out

#Conversion FQ1 into fasta file
REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
REPF1=REPF1 + "*.java"
REPF=commands.getstatusoutput(REPF1)
print REPF

FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ RepeatMaskerFormat /mnt/mfiles/" + nfolder
FQ12FASTA=FQ12FASTA + "/"
FQ12FASTA=FQ12FASTA + nnFILE1
FQ12FASTA=FQ12FASTA + " /mnt/mfiles/"
FQ12FASTA=FQ12FASTA + nfolder
FQ12FASTA=FQ12FASTA + "/"
FQ12FASTA=FQ12FASTA + nFASTA
FQ12FASTA=FQ12FASTA + " FQ1"
p6=commands.getstatusoutput(FQ12FASTA);
print p6

#Get the readlength
JAVA1="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ findreadlength /mnt/mfiles/" + nfolder
JAVA1=JAVA1 + "/"
JAVA1=JAVA1 + nnFILE1
readlength1=commands.getstatusoutput(JAVA1);
print "READLENGTH"
print readlength1

readlength = str(readlength1[1])

# Velvet Contig Generation starts
velvet="/root/velvet_0.7.63/velveth /mnt/mfiles/contig 31 -fasta -short /mnt/mfiles/" + nfolder
velvet=velvet + "/"
velvet=velvet + nFASTA
p6=commands.getstatusoutput(velvet);
print p6

velvet="/root/velvet_0.7.63/velvetg /mnt/mfiles/contig -min_contig_lgth "+readlength
print velvet
p6=commands.getstatusoutput(velvet);

#Total reads  - STATISTICS
STAT1="/bin/grep \">\" /mnt/mfiles/contig/contigs.fa" + " | wc -l" 
STAT1=STAT1 + " > /mnt/mfiles/reads/"
STAT1=STAT1 + sCON
STAT=commands.getstatusoutput(STAT1);
print STAT

#Upload the Statistics of contigs
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sCON
out1=out1 + " s3://"
out1=out1 + stat
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)

#Conversion Fasta to Fa file
pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
pp1f1=pp1f1 + "*.java"
p1f2=commands.getstatusoutput(pp1f1)
print pp1f1

FAS2FQ1="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ Fas2FQ1 /mnt/mfiles/contig/contigs.fa /mnt/mfiles/contig/contigs.fq1"
p6=commands.getstatusoutput(FAS2FQ1);

# Number FQ1
NFQ1="/usr/bin/wc -l < /mnt/mfiles/contig/contigs.fq1"
NFQ=commands.getstatusoutput(NFQ1);

	
nlineFQ1 = int(NFQ[1])

nChunk=str(1500)

if nlineFQ1 > 30000:
	nChunk1=int(nlineFQ1/(nclus*2)) + 1
	#nChunk=str(nChunk1)
	if nChunk1 > 750:
		nChunk=str(750)
	else:
		nChunk=str(nChunk1)
else:
	nChunk1=int(nlineFQ1/nclus) + 1
	if nChunk1 > 750:
		nChunk=str(750)
	else:
		nChunk=str(nChunk1)
	
print "contigs"
print nChunk

#Divide into chunks of nChunk sequences per file
pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
pp1f1=pp1f1 + "*.java"
p1f2=commands.getstatusoutput(pp1f1)
print pp1f1

# CHUNK CREATER
CHUNK="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ FileSplitter_S3bucket /mnt/mfiles/contig/contigs.fq1 " + nChunk
CHUNK=CHUNK + " contigs.fq1 "
CHUNK=CHUNK + " NONE "
CHUNK=CHUNK + velinput 
print CHUNK
p6=commands.getstatusoutput(CHUNK);
print p6

# remove contigs.fq1
cat1="/bin/rm -f /mnt/mfiles/contig/contigs.fq1"
wget=commands.getstatusoutput(cat1)

#Upload contigs fq1 files to S3 Bucket
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put -r /mnt/mfiles/contig/*.fq1 s3://" + velinput
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)



#Upload manifest files to Hadoop <postvelvetman>
out1=hadooploc + "/bin/hadoop fs -mkdir postvelvetman"
out=commands.getstatusoutput(out1)

out1=hadooploc + "/bin/hadoop fs -put /mnt/mfiles/contig/*.man postvelvetman"
out=commands.getstatusoutput(out1)
print out

# remove all files
cat1="/bin/rm -r /mnt/mfiles/contig/"
wget=commands.getstatusoutput(cat1)
# Velvet Contig Generation ends



# For POST SUBSTRACTION STARTS
# Number FQ1
NFQ1="/usr/bin/wc -l < /mnt/mfiles/" + nfolder
NFQ1=NFQ1 + "/" 
NFQ1=NFQ1 + nnFILE1
NFQ=commands.getstatusoutput(NFQ1);

nlineFQ1 = int(NFQ[1])
nChunk=str(1500)
if nlineFQ1 > 30000:
	nChunk1=int(nlineFQ1/(nclus*2)) + 1
	#nChunk=str(nChunk1)
	
	if nChunk1 > 10000:
		nChunk=str(10000)
	else:
		nChunk=str(nChunk1)

else:
	
	nChunk1=int(nlineFQ1/nclus) + 1
	if nChunk1 > 10000:
		nChunk=str(10000)
	else:
		nChunk=str(nChunk1)

print "unmapped"
print nChunk

#Divide into chunks of 1500 sequences per file
pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
pp1f1=pp1f1 + "*.java"
p1f2=commands.getstatusoutput(pp1f1)
print pp1f1

# CHUNK CREATER......SEQUENCE FILE.....
CHUNK="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ FileSplitter_S3bucket /mnt/mfiles/" + nfolder
CHUNK=CHUNK + "/" 
CHUNK=CHUNK + nnFILE1
CHUNK=CHUNK + " "
CHUNK=CHUNK + nChunk
CHUNK=CHUNK + " "
#CHUNK=CHUNK + " 1500 "
CHUNK=CHUNK + nnFILE1
CHUNK=CHUNK + " NONE "
CHUNK=CHUNK + output
print CHUNK
p6=commands.getstatusoutput(CHUNK);
print p6
 
# remove concated files
#cat1="/bin/rm -f /mnt/mfiles/" + nfolder
#cat1=cat1 + "/"
#cat1=cat1 + nnFILE1
#wget=commands.getstatusoutput(cat1)

#Upload fq1 files to S3 Bucket
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put -r /mnt/mfiles/" + nfolder
out1=out1 + "/*.fq1 "
out1=out1 + "s3://"
out1=out1 + output
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)

#Upload manifest files to Hadoop <postunmappedman>
out1=hadooploc + "/bin/hadoop fs -mkdir postunmappedman"
out=commands.getstatusoutput(out1)

out1=hadooploc + "/bin/hadoop fs -put /mnt/mfiles/" 
out1=out1 + nfolder
out1=out1 + "/*.man postunmappedman"
print out1
out=commands.getstatusoutput(out1)


# remove all files
#cat1="/bin/rm -r /mnt/mfiles/" + nfolder
#wget=commands.getstatusoutput(cat1)
