#!/bin/csh
##############################################################################
#	Program: Uploading Reference Genomes into the S3Bucket
#	Input: Download from the Reference Genome and Upload them into the S3 Bucket (s3://ami-pathseqref)
#	Input parameters: 	
#	
#	Written: Chandra Sekhar Pedamallu
#	Copyright@DFCI, The Broad Institute
#############################################################################
echo "Creation of your Amazon Machine Image"
set ldir = `pwd`

cp cluster.config $ldir/Build_OwnAMI/ 

$ldir/Build_OwnAMI/create-h-image $*

echo "Creation completed"

rm install_cross
rm install_rlib
