
import java.util.ArrayList;

public class Group {

	private String group;
	private ArrayList<SequenceEntry> matchingReads= new ArrayList<SequenceEntry>();
	
	public Group( String groupName, SequenceEntry seq) {
		setGroup(groupName);
		matchingReads.add(seq);
	}

	
	
	
	
	//Getters and Setters
	
	public void setGroup(String group) {
		this.group = group;
	}

	public String getGroup() {
		return group;
	}
	
	public void addToMatchingReads(SequenceEntry matchingRead) {
		this.matchingReads.add(matchingRead);
	}

	public ArrayList<SequenceEntry> getMatchingReads() {
		return matchingReads;
	}
}
